//============================================================================
//  aPCI-P31A for PCI Linux Device Driver
//  apci31a.h
//  Author  Shoichiro Ito(ADTEK SYSTEM SCIENCE Co.,Ltd.)
//  Date    2001/03/15
//  Rev.    1.0.0
//============================================================================


#ifndef __INC_APCI31A_H__
#define __INC_APCI31A_H__


//-----------------------------------------------------------
//  Macros to help debugging
//-----------------------------------------------------------

#undef PDEBUG		  /* undef it, just in case */
#ifdef APCI31A_DEBUG
#	ifdef __KERNEL__
		/* This one if debugging is on, and kernel space */
#		define PDEBUG(fmt, args...) printk(KERN_DEBUG "[APCI31A]: " fmt, ## args)
#	else
		/* This one for user space */
#		define PDEBUG(fmt, args...) fprintf(stderr, fmt, ## args)
#	endif
#else
#	define PDEBUG(fmt, args...) /* not debugging: nothing */
#endif

#undef PDEBUGG
#define PDEBUGG(fmt, args...) /* nothing: it's a placeholder */


//-----------------------------------------------------------
//  Miscellaneous
//-----------------------------------------------------------

#define APCI31A_MAX_DEVICES	16		// ǥХ
#define APCI31A_MAX_PORTS	4		// IO ݡȿ
#define APCI31A_MAX_IRQS	4		// װ


//-----------------------------------------------------------
//  Device I/O Defined
//-----------------------------------------------------------

// Input/Output Ports
#define APCI31A_IO_PORT_1	0x00
#define APCI31A_IO_PORT_2	0x01
#define APCI31A_IO_PORT_3	0x02
#define APCI31A_IO_PORT_4	0x03

// Input Ports
#define APCI31A_BSN_PORT	0x0F		// BSN


// Offset 0x0F	    APCI31A_BSN_PORT(I)
#define APCI31A_GET_BSN(n) ((n >> 4) & 0x0F)	// BSN ޥ


//-----------------------------------------------------------
//  Device I/O Control Codes
//-----------------------------------------------------------

#define APCI31A_IOC_MAGIC  'Z'

#define APCI31A_IN_PORT    _IOWR(APCI31A_IOC_MAGIC, 0, apci31a_io)
#define APCI31A_OUT_PORT   _IOW (APCI31A_IOC_MAGIC, 1, apci31a_io)
#define APCI31A_GET_IFR    _IOR (APCI31A_IOC_MAGIC, 2, unsigned char)
#define APCI31A_GET_ICR    _IOR (APCI31A_IOC_MAGIC, 3, unsigned short)
#define APCI31A_SET_ICR    _IOW (APCI31A_IOC_MAGIC, 4, unsigned short)

#define APCI31A_IOC_MAXNR  4


// TODO:  桼ץꥱȤ̿Ѥǡ¤򤳤˵Ҥޤ

typedef struct _apci31a_io
{
	unsigned int  port;
	unsigned char value;
} apci31a_io, *papci31a_io;


#endif // __INC_APCI31A_H__
