//============================================================================
//  aPCI-P31A Device Driver I/F Control
//  apci31actl.h
//  Author  Shoichiro Ito(ADTEK SYSTEM SCIENCE Co.,Ltd.)
//  Date    2000/03/15
//  Rev.    1.0.0
//============================================================================

#ifndef __INC_APCI31ACTL_H__
#define __INC_APCI31ACTL_H__

#include "apci31a.h"

#ifdef __cplusplus
extern "C" {
#endif


//----------------------------------------------------------------------------
//  Miscellaneous
//----------------------------------------------------------------------------

#define APCI31A_BSN_AUTO	((int)~0)	// ̤ѥǥХθ


//----------------------------------------------------------------------------
//  Error Codes
//----------------------------------------------------------------------------

#define APCI31A_OK		 0	// ｪλ
#define APCI31A_ESYSCALL	-1	// ƥॳ륨顼
#define APCI31A_EINVAL		-2	// ʰ
#define APCI31A_ENODEV		-3	// ǥХϸդʤ
#define APCI31A_EBUSY		-4	// ¹ޤϻ
#define APCI31A_ESISR		-5	// ߥ롼ꥨ顼


//----------------------------------------------------------------------------
// Control Functions
//----------------------------------------------------------------------------

int apci31a_create	(int bsn);
int apci31a_close	(int bsn);
int apci31a_inp		(int bsn, int port, unsigned char* pdata);
int apci31a_outp	(int bsn, int port, unsigned char data);
int apci31a_get_ifr	(int bsn, unsigned char* pifr);
int apci31a_get_icr	(int bsn, unsigned short* picr);
int apci31a_set_icr	(int bsn, unsigned short icr);
int apci31a_setup_int	(int bsn, void(*pcallback)(int bsn, void* arg), void* arg);
int apci31a_cancel_int	(int bsn);


#ifdef __cplusplus
}
#endif


#endif // __INC_APCI31ACTL_H__